1;

my $STATE_SEP = ':::';

sub ControlSearn {
    my ($Load, $Num, $Example, $Actions, $Features, $Cost, $Step, $Loss, $OverallLoss) = @_;

    $|++;   # get IO to be strict

    print "OK\n";  # we're ready to go!

    # begin command loop
    while (<>) {
        chomp;
        my $quit = 0;
        switch: {
            /^quit$/         && do { 
                $quit = 1; 
                print "OK\n";
                last switch; };
            
            /^load (.+)$/    && do { 
                $Load->($1); 
                print "OK\n";
                last switch; };

            /^num$/          && do {
                my $ret = $Num->();
                print "OK $ret\n";
                last switch; };

            /^example (.+)$/ && do {
                my @state = $Example->($1);
                print "OK " . (join $STATE_SEP, @state) . "\n";
                last switch; };

            /^actions (.+)$/ && do {
                my @state = split /$STATE_SEP/, $1;
                my @a = $Actions->(@state);
                print "OK";
                foreach my $a (@a) { print ' ' . $a; }
                print "\n";
                last switch; };

            /^features (.+)$/ && do {
                my @state = split /$STATE_SEP/, $1;
                my %f = $Features->(@state);
                print "OK";
                foreach my $f (keys %f) { print ' ' . $f . ' ' . $f{$f}; }
                print "\n";
                last switch; };

            /^action_features ([^\s]+) ([^\s]+)$/ && do {
                my $action = $2;
                my @state = split /$STATE_SEP/, $1;
                my %f = $Features->($action, @state);
                print "OK";
                foreach my $f (keys %f) { print ' ' . $f . ' ' . $f{$f}; }
                print "\n";
                last switch; };

            /^cost ([^\s]+) ([^\s]+)$/ && do {
                my $action = $2;
                my @state  = split /$STATE_SEP/, $1;
                my $c = $Cost->($action, @state);
                print "OK $c\n";
                last switch; };

            /^step ([^\s]+) ([^\s]+)$/ && do {
                my $action = $2;
                my @state  = split /$STATE_SEP/, $1;
                my @state2 = $Step->($action, @state);
                print "OK " . (join $STATE_SEP, @state2) . "\n";
                last switch; };

            /^loss (.+)$/ && do {
                my @state = split /$STATE_SEP/, $1;
                my $l = $Loss->(@state);
                print "OK $l\n";
                last switch; };

            /^overall_loss$/ && do {
                my $l = $OverallLoss->();
                print "OK $l\n";
                last switch; };

            # error handling
            die "unknown command: '$_'\n";
        }
        if ($quit) { last; }
    }
}


